#include <avr/io.h>
#include <avr/interrupt.h>
#include "pc6031.h"
#include "spi.h"

#if PC6031_USE_OLED
#include "oled.h"
#endif /* PC6031_USE_OLED */


FUSES = {0xFF, 0xD8, 0xFD};	/* Low, High, Extended */

extern volatile BYTE	APPIC_OUT;		/* |[gC̏o̓f[^ */
extern volatile BYTE	SD_OUTENB;		/* SDCl[u */

int main(void)
{

	DDRA  = 0b00000000;		/* CPLD I/F (of[^) */
	PORTA = 0b11111111;

	DDRB  = 0b10110011;		/* SCK, MISO, MOSI, SD_CS, SD_CD, SD_WP, LED_R, LED_G */
	PORTB = 0b11111100;		/* vAbv */

	DDRC  = 0b00001000;		/* TDO, TCK, TMS, TDI, LED_B, -, SDA, SCL */
	PORTC = 0b11110111;		/* vAbv */

	DDRD  = 0b01111111;		/* CPLD I/F (p) */
	PORTD = 0b11111111;		/* vAbv */

	if ( FIRMWRITTEN ) {		/* t@[͓삳Ȃ */
		for (;;) {
		}
	}

	TCCR1A = 0b00000000;
	TCCR1B = 0b00001000;

	TCCR2A = 0b00000000;
	TCCR2B = 0b00000111;	/* TIMER2 1/1024 */
	TIMSK2 = 0b00000001;	/* TIMER2ꊄ荞݋ */

	PIO_B_OUT(0x00);
	APPIC_OUT = 0x00;
	PIO_C_OUT();

	sei();

	SD_DISABLE();

	init_spi();

#if PC6031_USE_OLED
	oled_init();
#endif /* PC6031_USE_OLED */

	PC6031_main();

	return(0);
}

