#include <avr/io.h>			/* Device specific include files */
#include "pff.h"			/* include UINT/BYTE/... */

#ifndef _OLED_DEFINED
#define _OLED_DEFINED

#if PC6031_OLED_USE_I2C
#define BAUDRATE				400000
#define TWI_BAUDSETTING 		( ((F_CPU/BAUDRATE)-16)/2 )
#define	OLED_I2C_ADDRESS	0x78				/* 0111100 R/W */
#define	OLED_I2C_COMMAND	0b00000000			/* Co D/C 000000 */
#define	OLED_I2C_DATA		0b01000000			/* Co D/C 000000 */
#else /* PC6031_OLED_USE_I2C */
#define OLED_CS_LOW()		PORTB &= ~_BV(0)	/* Set CS low */
#define	OLED_CS_HIGH()		PORTB |=  _BV(0)	/* Set CS high */
#define OLED_RST_LOW()		PORTB &= ~_BV(3)	/* Set RESET low */
#define	OLED_RST_HIGH()		PORTB |=  _BV(3)	/* Set RESET high */
#define OLED_SET_COMMAND()	PORTB &= ~_BV(1)	/* Set DC low */
#define	OLED_SET_DATA()		PORTB |=  _BV(1)	/* Set DC high */
#endif /* PC6031_OLED_USE_I2C */

#define	FONT_HEIGHT	12

void oled_command(BYTE);
void oled_data(BYTE);
void oled_init(void);
void oled_setline(BYTE);
void oled_putcdt(BYTE, BYTE);
void oled_putsdt(char *, BYTE);

void oled_dispver(char *);
void oled_dispfile(void);

void oled_drawmode(void);
void oled_fontmode(void);
void oled_drawinv(void);
void oled_drawnoinv(void);
void oled_setcursor(BYTE, BYTE);
void oled_setdata(BYTE);


#define	oled_putc(d)	oled_putcdt(d, 0x00)
#define	oled_putcinv(d)	oled_putcdt(d, 0xff)
#define	oled_puts(d)	oled_putsdt(d, 0x00)
#define	oled_putsinv(d)	oled_putsdt(d, 0xff)

#endif /* _OLED_DEFINED */
