
#ifndef _PC6031_AVR_DEFINED
#define _PC6031_AVR_DEFINED

#ifndef F_CPU
#define	F_CPU		10000000UL
#endif

#include <util/delay.h>
#include "pff.h"

#define	VER_NO		"125"		/* o[Wԍ */
#define	MODEL_NO	"RE"		/* @ԍ */
#define	HW_VERNO	'0','1'		/* n[hEGAԍ */

#define	PC6031_USE_QBYTE		1		/* 4oCg] use */
#define	PC6031_USE_OLED			1		/* OLED use */
#define	PC6031_OLED_USE_I2C		1		/* I2C use */
#define	PC6031_ROM_USE			1		/* ROM use */

#define	LEDB_ON()		PORTC |=  _BV(3)			/* LED_ */
#define	LEDB_OFF()		PORTC &= ~_BV(3)			/* LED */
#define	LEDG_ON()		PORTB |=  _BV(0)			/* LEDΓ_ */
#define	LEDG_OFF()		PORTB &= ~_BV(0)			/* LEDΏ */
#define	LEDR_ON()		PORTB |=  _BV(1)			/* LEDԓ_ */
#define	LEDR_OFF()		PORTB &= ~_BV(1)			/* LEDԏ */

#define	IS_P6_RESET		!(PIND & _BV(7))			/* P6ZbgH */

#define	IS_ATN_HIGH		(PIO_C_IN() & _BV(3))		/* MATNHH */
#define	IS_DAC_HIGH		(PIO_C_IN() & _BV(2))		/* MDACHH */
#define	IS_RFD_HIGH		(PIO_C_IN() & _BV(1))		/* MRFDHH */
#define	IS_DAV_HIGH		(PIO_C_IN() & _BV(0))		/* MDAVHH */

#define	IS_ATN_LOW		!(PIO_C_IN() & _BV(3))		/* MATNLH */
#define	IS_DAC_LOW		!(PIO_C_IN() & _BV(2))		/* MDACLH */
#define	IS_RFD_LOW		!(PIO_C_IN() & _BV(1))		/* MRFDLH */
#define	IS_DAV_LOW		!(PIO_C_IN() & _BV(0))		/* MDAVLH */

#define	ATN_HIGH()		{ APPIC_OUT |= _BV(7);PIO_C_OUT(); }	/* MATNHɂ */
#define	DAC_HIGH()		{ APPIC_OUT |= _BV(6);PIO_C_OUT(); }	/* MDACHɂ */
#define	RFD_HIGH()		{ APPIC_OUT |= _BV(5);PIO_C_OUT(); }	/* MRFDHɂ */
#define	DAV_HIGH()		{ APPIC_OUT |= _BV(4);PIO_C_OUT(); }	/* MDAVHɂ */

#define	ATN_LOW()		{ APPIC_OUT &= ~_BV(7);PIO_C_OUT(); }	/* MATNLɂ */
#define	DAC_LOW()		{ APPIC_OUT &= ~_BV(6);PIO_C_OUT(); }	/* MDACLɂ */
#define	RFD_LOW()		{ APPIC_OUT &= ~_BV(5);PIO_C_OUT(); }	/* MRFDLɂ */
#define	DAV_LOW()		{ APPIC_OUT &= ~_BV(4);PIO_C_OUT(); }	/* MDAVLɂ */

#define	PIO_A_IN_B_IN()		{ ; }					/* |[gÁA|[gB͂ɂ */
#define	PIO_A_IN_B_OUT()	{ ; }					/* |[gÁA|[gBo͂ɂ */
#define	PIO_A_OUT_B_OUT()	{ ; }					/* |[gAóA|[gBo͂ɂ */

#define	SND_B(d)		PIO_B_OUT(d)				/* f[^𑗐M(|[gB) */
#define	RCV_A			PIO_A_IN()					/* f[^M(|[gA) */
#define	SND_A(d)		PIO_A_OUT(d)				/* f[^𑗐M(|[gAF4oCg]p) */
#define	RCV_B			PIO_B_IN()					/* f[^M(|[gBF4oCg]p) */

#define	IS_TIMER_END	!(TIM5S & 0x01)				/* 5b^C}H */
#define	IS_SD_INSERT	!(PINB & _BV(3))			/* SDJ[h}ĂH */
#define	IS_SD_EJECT		(PINB & _BV(3))				/* SDJ[hĂH */
#define	IS_SD_WP		(PINB & _BV(2)) 			/* SDJ[hCgveNgH */

#define	SD_ENABLE()		SD_OUTENB = 0x01			/* SDJ[hL */
#define	SD_DISABLE()	SD_OUTENB = 0x00			/* SDJ[h𖳌 */
#define	IS_SD_ENABLE	(SD_OUTENB & 0x01)			/* SDJ[hLH */
#define	IS_SD_DISABLE	!(SD_OUTENB & 0x01)			/* SDJ[hH */

#define	REBOOT()		{ cli(); asm volatile ("jmp 0"); }	/* ċN */

#define	RSTWAIT		15			/* Zbg҂ */

// whether firmware has been written in the bootloader or not
#define FIRMWRITTEN GPIOR0

#define	OLED_START	0x01		/* OLED Jn */
#define	OLED_END	0x02		/* OLED I */
#define	OLED_INV	0x03		/* OLED ] */
#define	OLED_NOINV	0x04		/* OLED ]߂ */

BYTE PIO_A_IN(void);				/* |[gAf[^͂ */
BYTE PIO_B_IN(void);				/* |[gBf[^͂ */
BYTE PIO_C_IN(void);				/* |[gCf[^͂ */
void PIO_A_OUT(BYTE);				/* |[gAɃf[^o͂ */
void PIO_B_OUT(BYTE);				/* |[gBɃf[^o͂ */
void PIO_C_OUT(void);				/* |[gCɃf[^o͂ */

#define nop() __asm__ __volatile__ ("nop");

#endif /* _PC6031_AVR_DEFINED */
