#ifndef _BOOTLOADER_DEFINED
#define _BOOTLOADER_DEFINED

#define	F_CPU		10000000UL
#include <util/delay.h>
#include <avr/io.h>
#include <avr/boot.h>
#include <stdlib.h>
#include <string.h>
#include "pff.h"

#define	AVR_HEXFILE	"AVR.HEX"
#define	AVR_SVFFILE	"CPLD.SVF"

#define	LEDG_ON()		PORTB |=  _BV(0)			/* LEDΓ_ */
#define	LEDG_OFF()		PORTB &= ~_BV(0)			/* LEDΏ */
#define	LEDR_ON()		PORTB |=  _BV(1)			/* LEDԓ_ */
#define	LEDR_OFF()		PORTB &= ~_BV(1)			/* LEDԏ */

#define	IS_SD_EJECT		(PINB & _BV(3))				/* SDJ[hĂH */

#define	MAXBIN			0x100						/* HEXt@CPs̍őoCg */
#define	READBUFNUM		0x200						/* SDJ[h̓ǂݏoobt@ */

typedef enum {
	UNKNOWN,
	RUN_IDLE,
	SHIFT_DR,
	SHIFT_IR,
	PAUSE_IR,

	TAP_STATE_NUM
} TAP_STATE;

FRESULT bootloader(void);
void boot_program_page (DWORD, BYTE*);
FRESULT readdata(BYTE *);

FRESULT svfloader(void);
void state_out(TAP_STATE*, TAP_STATE);
BYTE set_tapsig(BYTE, BYTE);
void set_tdisig(DWORD, char*);
FRESULT set_tdiosig(DWORD, char*, char*, char*);
void set_tcksig(DWORD);

#define nop() __asm__ __volatile__ ("nop");

#endif /* _BOOTLOADER_DEFINED */
