#include <avr/io.h>
#include <avr/interrupt.h>
#include "bootloader.h"

FUSES = {0xFF, 0xD8, 0xFD};	/* Low, High, Extended */

int main(void)
{
	FRESULT	res;
	BYTE	i;

	DDRA  = 0b00000000;
	PORTA = 0b11111111;		/* vAbv */

	DDRB  = 0b10110011;		/* SCK, MISO, MOSI, SD_CS, SD_CD, SD_WP, LED_R, LED_G */
	PORTB = 0b11111100;		/* vAbv */

	DDRC  = 0b00000000;		/* TDO, TCK, TMS, TDI, -, -, SDA, SCL */
	PORTC = 0b11111111;		/* vAbv */

	DDRD  = 0b00000000;
	PORTD = 0b11111111;		/* vAbv */

	_delay_ms(500);
	_delay_ms(500);

	res = bootloader();
	if ( !res ) {
		res = svfloader();
	}

	GPIOR0 = res;

	if        (res == 255) {	// AVR firmware written
		LEDG_ON();
		_delay_ms(500);
		LEDG_OFF();
		_delay_ms(500);
		LEDG_ON();
		_delay_ms(500);
		LEDG_OFF();
		_delay_ms(500);
	} else if (res == 254) {	// CPLD circuit written
		LEDG_ON();
		_delay_ms(500);
		LEDG_OFF();
		_delay_ms(500);
		LEDG_ON();
		_delay_ms(500);
		LEDG_OFF();
		_delay_ms(500);
		LEDG_ON();
		_delay_ms(500);
		LEDG_OFF();
		_delay_ms(500);
		LEDG_ON();
		_delay_ms(500);
		LEDG_OFF();
		_delay_ms(500);
	} else if (res != 0) {		// error
		for (;;) {
			for (i = 0;i < res;i ++) {
				LEDR_ON();
				_delay_ms(250);
				LEDR_OFF();
				_delay_ms(250);
			}
			_delay_ms(250);
			_delay_ms(250);
		}
	}

	asm volatile ("jmp 0");
	return 0;
}

